/* ----------------------------------------------------------
(c) 2007 Sylvain Lefebvre - all rights reserved
--
The source code is provided 'as it is', without any warranties. 
Use at your own risk. The use of any part of the source code in a
commercial or non commercial product without explicit authorisation
from the author is forbidden. Use for research and educational
purposes is allowed and encouraged, provided that a short notice
acknowledges the author's work.
---------------------------------------------------------- */
// ------------------------------------------------------
//
// A simple trackball implementation
//
// ------------------------------------------------------
// Sylvain Lefebvre - 2006-11-29
// ------------------------------------------------------

#pragma once

#define TRANSLATING 1
#define ROTATING    2
#define ZOOMING     4

#define LEFT_BUTTON   1
#define MIDDLE_BUTTON 2
#define RIGHT_BUTTON  3

#include "Vertex.h"
#include "Quaternion.h"

void            trackballSetRadius(float r);
void            trackballSetCenter(const v3f& center);
const quatf&    trackballRotation();
const v3f&      trackballTranslation();
const m4x4f     trackballMatrix();
void            trackballStopMotion();

void trackballInit(uint w,uint h);
void trackballButtonPressed(uint button,uint x,uint y);
void trackballButtonReleased(uint button);
void trackballUpdate(uint x,uint y);

// ------------------------------------------------------
